<?php
/*
Plugin Name: S3 Content Downloader
Description: Plugin for downloading objects from S3 bucket using existing urls
Version: 1.0
Author: Sankara Narayanan
*/
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
class dcs3_ContentDownloader{
	public function __construct()
    {
		include_once(ABSPATH . 'wp-includes/pluggable.php');
		require_once( dirname(__FILE__) . "/s3-settings.php"); 
		if ( !is_admin())
		{
			add_action( 'init', array($this, 'getUrl') );
		}
	}	
    public function getUrl() {
		$url = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
		$filename = basename($url);
		$fileExtension = pathinfo($filename, PATHINFO_EXTENSION);
		// Check if file extension match with the pdf,xls,xlsx,doc,docx
		if($fileExtension == "pdf" || $fileExtension == "xls" || $fileExtension == "xlsx" || $fileExtension == "doc" || $fileExtension == "docx")
		{	
			require_once(dirname(__FILE__) ."/../../../wp-admin/includes/file.php");
			require 'vendor/aws/aws-autoloader.php';
			require_once( dirname(__FILE__) . "/data.php");
			require 's3-download-objects.php';
			
			die;
		}		 
	}
}
	$dcs3_ContentDownloader = new dcs3_ContentDownloader();
	register_activation_hook( __FILE__, 'dcs3_install' );
	register_deactivation_hook( __FILE__, 'dcs3_uninstall' );	
	require_once( dirname(__FILE__) . "/register.php");
?>