<?php
	use Aws\S3\Exception\S3Exception;
	use Aws\S3\S3Client;
	use Aws\Credentials\Credentials;
	use GuzzleHttp\Psr7;
	
	$credentials = new Credentials($accesskey, $secretkey);

	// Instantiate the S3 client with your AWS credentials
	
	try{
		//Create a S3Client
		$s3Client = S3Client::factory(array(
			'credentials' => $credentials,
			'region' => 'us-west-2',
			'version' => '2006-03-01',
			'scheme'  => 'http'
		));
		
		$path = get_home_path();
		$hostedFolder = basename($path);
		$urlKey = explode('/',parse_url($url, PHP_URL_PATH));
		
		unset($urlKey[0]);
		
		// Check if hosted folder equals to base folder in the URL path
		if( $hostedFolder == $urlKey[1]){
			unset($urlKey[1]);
		}
		
		$S3Url = implode('/',$urlKey);
		
		//If filename contains space.
		if(strpos($filename, '+') !== false){
			$S3Url = str_replace("+", " ", $S3Url);
		}
		
		//print_r($S3Url);die;
		
		// Get Object from S3 bucket
		$result = $s3Client->getObject(array(
			'Bucket' => $bucketname,
			'Key'    => $S3Url
		));
		
		//print($result['ContentType']);die;
		
		if($result['ContentType'] == "application/pdf"){
			header("Content-Type: {$result['ContentType']}");
			echo $result['Body'];
		}
		elseif($result['ContentType'] == "application/vnd.ms-excel"){
			$stream = Psr7\stream_for($result['Body']);
			$content = $stream->getContents();
			$size = $stream->getSize();
			$stream->close();
			header('Content-Description: File Transfer');
			//this assumes content type is set when uploading the file.
			header('Content-Type: ' . $result['ContentType']);
			header('Content-Disposition: attachment; filename=' . $filename);
			header('Expires: 0');
			header('Cache-Control: must-revalidate');
			header('Pragma: public');
			header('Content-Length: '.$size);

			//send file to browser for download. 
			ob_clean();
			flush();
			echo $content; die;
		}
		elseif($result['ContentType'] == "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"){
			$stream = Psr7\stream_for($result['Body']);
			$content = $stream->getContents();
			$size = $stream->getSize();
			$stream->close();
			header('Content-Description: File Transfer');
			//this assumes content type is set when uploading the file.
			header('Content-Type: ' . $result['ContentType']);
			header('Content-Disposition: attachment; filename=' . $filename);
			header('Expires: 0');
			header('Cache-Control: must-revalidate');
			header('Pragma: public');
			header('Content-Length: '.$size);

			//send file to browser for download. 
			ob_clean();
			flush();
			echo $content; die;
		}
		elseif($result['ContentType'] == "application/vnd.openxmlformats-officedocument.wordprocessingml.document")	{
			$stream = Psr7\stream_for($result['Body']);
			$content = $stream->getContents();
			$size = $stream->getSize();
			$stream->close();
			header('Content-Disposition: attachment;filename="' . $fileName . '"');
			header('Content-Length: '.$size);
			ob_clean();
			flush();
			echo $content; die;
		}
		elseif($result['ContentType'] == "application/msword")	{
			$stream = Psr7\stream_for($result['Body']);
			$content = $stream->getContents();
			$size = $stream->getSize();
			$stream->close();
			header('Content-Disposition: attachment;filename="' . $fileName . '"');
			header('Content-Length: '.$size);
			ob_clean();
			flush();
			echo $content; die;
		}
		else{
			echo "Error in Downloading the file, Contact site admin";
			
		}
	
	} catch (S3Exception $e) {
		echo "This file not available in S3 Storage </br>";
		echo $e->getMessage() . "\n";
	}			
?>